/*
 * AdjMatrixPanel.java
 *
 * Created on 27. Dezember 2000, 21:17
 */
 


/** 
 *
 * @author  fhofmann
 * @version 
 */

import java.awt.*;
import java.awt.event.*;

public class AdjPanel extends Panel implements ActionListener {
  Algorithm algorithm;
  CommunicationGraph cg;
  Button mybuttons[][]; 
  int dimension;
  Algorithm notifySystem = null;

  public AdjPanel(Algorithm a, CommunicationGraph cg) {
    this.algorithm = a;
    this.cg = cg;
    dimension = cg.dimension; 
    add_buttons();
  }

  private void add_buttons() {
    mybuttons= new Button[dimension + 1][dimension + 1];
    setLayout(new GridLayout(dimension + 1, dimension + 1));

    // the corner-button
    mybuttons[0][0] = new Button(" ");
    mybuttons[0][0].setForeground (Color.black); 
    mybuttons[0][0].setBackground (Color.gray); 
    add (mybuttons[0][0]);

    // the first line is just for heading
    for (int i = 1; i < dimension + 1; i++) { 
       mybuttons[0][i] = new Button("" + i); 
       mybuttons[0][i].setForeground (Color.black); 
       mybuttons[0][i].setBackground (Color.gray); 
       add (mybuttons[0][i]);}

    // now insert the buttons; use Grid-Layout to set them correct
    for (int i = 1; i < dimension + 1; i++) { 
      mybuttons[i][0] = new Button("" + i); 
      mybuttons[i][0].setForeground (Color.black); 
      mybuttons[i][0].setBackground (Color.gray); 
      add (mybuttons[i][0]);
      for (int j = 1; j < dimension + 1; j++) {
        mybuttons[i][j] = new Button("  ");
        mybuttons[i][j].setForeground (Color.black); 
        mybuttons[i][j].setBackground (Color.lightGray); 
        add (mybuttons[i][j]);
        mybuttons[i][j].addActionListener(this);
      }
    }
  }

  public void actionPerformed(ActionEvent e) {
    Koord k; 
    if ((k = detect_button(e.getSource())) != null) {
      invert(k); 
    } else System.out.println ("internal Error occured! no Button catched");
  }

  public void paint(Graphics g) {
    paintNodes();
  }

  protected void invert(Koord k) {
    boolean flag;
    if (flag = cg.test(k)) {
      cg.unset(k);
      if (notifySystem != null) notifySystem.deleteEdge(k);
    } else {
      cg.set(k);
      if (notifySystem != null) notifySystem.addEdge(k);
    }
    repaint();
  }

  protected Koord detect_button(Object w) {
    for (int i = 0; i < dimension + 1; i++)
      for (int j = 0; j < dimension + 1; j++)
        if (w == mybuttons[i][j])
    	  return new Koord(i - 1, j - 1);
    return null;
  }

  protected void paintNodes() {
    Koord k = new Koord();
    for (k.x = 0; k.x < dimension; k.x++)
       for (k.y = 0; k.y < dimension; k.y++)
            mark_node(k, cg.test(k));
  }

  protected void mark_node(Koord k, boolean b) {
   if (b) mybuttons[k.x+1][k.y+1].setLabel("X");
   else   mybuttons[k.x+1][k.y+1].setLabel(" ");
  }

  public void changeNotify(Algorithm s) {
    notifySystem = s;
  }
}
