import java.util.*;

import scheduler.*;
import sysPr.*;

public class BasicConnection {
  SimProcess source, destination;
  Semaphore empty, full, mutex;
  Semaphore messageArrived = null;
  Vector buffer = new Vector();
  
  public BasicConnection(SimProcess source, SimProcess destination) {
    this.source = source;
    this.destination = destination;
    empty = new Semaphore("E ", 100, source.scheduler);
    full = new Semaphore("F ", 0, source.scheduler);
    mutex = new Semaphore("M ", 1, source.scheduler);
  }
  
  public BasicConnection(SimProcess source, SimProcess destination,
			 Semaphore messageArrived) {
    this.source = source;
    this.destination = destination;
    empty = new Semaphore("E ", 100, source.scheduler);
    full = new Semaphore("F ", 0, source.scheduler);
    mutex = new Semaphore("M ", 1, source.scheduler);
    this.messageArrived = messageArrived;
  }
  
  public void send(String type) {
    BasicMessage message = new  BasicMessage(source, destination, type, 2);
    message.print(source.getName() + " ---> " + destination.getName() + ": ");
    xmit(message);
  }
  
  public BasicMessage receive() {
    BasicMessage message = null;
    message = xrcv();
    message.destination.setTime(message.timestamp < destination.getTime() ?
			       destination.getTime() + 1 : message.timestamp + 1); 
    // message.print(destination.getName() + " <--- " + source.getName() + ": ");
    return message;
  }
  
  public synchronized void xmit(BasicMessage message) {
    SimProcess destination = message.destination;
    empty.p();
    mutex.p();
    buffer.addElement(message);
    full.v();
    if (messageArrived != null) {
      messageArrived.v();
    }
    mutex.v();
    ((Algorithm)(destination.scheduler.system)).getGraphFrame().stateChanged();
  }
  
  BasicMessage xrcv() {
    BasicMessage message;
    SimProcess process; 
    full.p();
    mutex.p();
    message = (BasicMessage)(buffer.elementAt(0));
    process = message.destination;
    buffer.removeElementAt(0);
    for (int i = 0; i < buffer.size(); i++) {
      if (((BasicMessage)(buffer.elementAt(i))).deliveringTime
	  <= ((Algorithm)(destination.scheduler.system)).getSimulationTime()) {
	((BasicMessage)(buffer.elementAt(i))).deliveringTime 
	  = ((Algorithm)(process.scheduler.system)).getSimulationTime() + 1;
      }
    }
    empty.v();
    mutex.v();
    return message;
  }
  
  public void print(String string) {
    SystemPrinter.println(string + "source =" +  source.getName()
			  + ", destination = " + destination.getName());
  }
}
    
