/*
 * GraphCanvas.java
 *
 * Created on 26. November 2000, 10:39
 */
 


/** 
 *
 * @author  fhofmann
 * @version 
 */
import java.awt.*;
import java.awt.event.*;

import sysPr.*;

public class GraphCanvas extends Canvas {
  GraphLayout ms;
  Algorithm algorithm;
  int mousemovenode;

  /** Creates new GraphCanvas */
  public GraphCanvas(Algorithm a) {
    // Instantiating GraphCanvas
    this.algorithm = a;
    ms = new GraphLayout(a);
    doLayout();
    //
    //setup our Mouse-Event-Adapters
    //
    this.addMouseListener(new MouseAdapter() {

      public void mousePressed(MouseEvent e) {
    	mousemovenode = ms.getnodehandle(new Koord(e.getX(),e.getY()));
    	if (mousemovenode >= 0) ms.invertnode(mousemovenode);
    	if (e.getClickCount() > 1) doubleclick_action(mousemovenode, e.getClickCount());
    	  repaint();
      }

      public void mouseReleased(MouseEvent e) {
    	Koord k = new Koord (e.getX(),e.getY());
    	if (mousemovenode >= 0) {
	  if (ms.getnodehandle(k) != mousemovenode)
	    if (contains (k.x,k.y))
	      ms.newkoord(mousemovenode, k);
	  ms.invertnode(mousemovenode);
      	}
        repaint();
      }
    }); 

    this.addMouseMotionListener ( new MouseMotionAdapter() {

	public void mouseDragged(MouseEvent e) {
    		Koord k = new Koord (e.getX(),e.getY());
    		if (mousemovenode >= 0)
      		if (ms.getnodehandle(k) != mousemovenode)
        		if (contains (k.x,k.y))
             			ms.newkoord(mousemovenode, k);
    		repaint();
        }
    });
  }
  
  public void doLayout() {
    ms.doLayout();
    repaint();
  }
  
  public void paint(Graphics g) {
    ms.paint(g);
  }
  
  protected void doubleclick_action(int nodeid, int count) {
    ms.doubleclick_action(nodeid, count);
  }
  
  public void addEdge(Koord k) {
    SystemPrinter.println("********** GraphCanvas.addEdge not yet implemented!");
  }

  public void deleteEdge(Koord k) {
    SystemPrinter.println("********** GraphCanvas.deleteEdge not yet implemented!");
  }
}