import java.awt.Graphics;
import java.awt.Color;
import java.awt.FontMetrics;
import java.awt.Rectangle;

public class GraphNode
{
  Koord mykoord;
  Koord dim; 
  String mylabel;
  // protected DNodeComment mycomment;

  Color defaultcolor = Color.white;    //normal state
  Color invertcolor  = Color.blue;     //if i'm clicked
  Color initiatorcolor = Color.yellow; //if i'm initiator
  Color actcolor;                      //actual state to be painted
  Color mymsgcolor   = Color.blue;     //my messages... if the messages don't get the choice
 
  // k is Coord, d is height and width
  public GraphNode(int n, Koord k, Koord d) 
  {  
     // super(n);
     mylabel = String.valueOf(n + 1);
     mykoord  = (Koord)k.clone();
     dim      = (Koord)d.clone();
     // mylabel  = new String ("" + mynumber);
     actcolor = defaultcolor; 
  }

  public GraphNode(int n) {
    this (n, new Koord (25 * n, (5 + n) * n), new Koord(20, 20));
  }

  public void be_initiator() {  //override the HistoryNode.be_initiator()
    // super.be_initiator(); 
    defaultcolor = initiatorcolor;
  }

  public void paint(Graphics g)
  {
    FontMetrics fm = g.getFontMetrics();
    g.setColor (actcolor);
    g.fillRect (mykoord.x, mykoord.y, dim.x, dim.y);
    g.setColor (Color.black);
    g.drawRect (mykoord.x, mykoord.y, dim.x, dim.y);
    g.drawString(mylabel, 
                 mykoord.x+(dim.x - fm.stringWidth(mylabel))/2, 
                 mykoord.y+(dim.y + fm.getAscent())/2 );
  }

  public void invert()
  { 
    if (actcolor == defaultcolor) actcolor = invertcolor;
    else                          actcolor = defaultcolor;
  } 
  public void set_color(Color c)
  {
     actcolor = defaultcolor = c;
  }
 
  public void  setx(int x)       {mykoord.x = x; 
	                          notify_koords();}
  public void  sety(int y)       {mykoord.y = y;
	                          notify_koords();}
  public void  setkoord(Koord k) {mykoord.x = k.x; mykoord.y = k.y;
	                          notify_koords();}
  public void  setdim(Koord d)   {dim.x = d.x; dim.y = d.y;} 
  public int   getx()            {return mykoord.x;}
  public int   gety()            {return mykoord.y;}
  public Koord getkoord()        {return mykoord;}
  public Koord getdim()          {return dim;}

  public boolean is_in(Koord k) {
    Rectangle r = new Rectangle(mykoord.x, mykoord.y, dim.x, dim.y);
    return (r.contains(k.x, k.y));
  }

  private void notify_koords() {
    // if (mycomment != null) {mycomment.notify_koords (mykoord, dim);}
  }

  
  /*
   public void set_commentator(DNodeComment d) {
    mycomment = d;
  }
  */

  public boolean doubleclick_action(int count) {
    be_initiator();
    return true;
  }

}
