import java.awt.*;
import java.util.Vector;

public class HistoryLayout {
// Canvas using this Layout
  History repr;
  Vector rounds;
  int numberOfNodes;

  public HistoryLayout(History repr) {
    this.repr = repr;
    this.rounds = repr.rounds;
    this.numberOfNodes = repr.numberOfNodes;
    for(int j = 0 ; j < numberOfNodes ; j++) {
      // Compute the initial coordinates of node j
      Koord k = (Koord) setkoord(j);
      ((HistoryRound) rounds.elementAt(repr.numberOfRound)).mynodes[j].setkoord(k);
    }      
  }
  
  // Calculate the position of new objects like new nodes and new GridMessages.
  public void roundNext(GridMessage []messages) 
  { HistoryRound r0 = ((HistoryRound) rounds.elementAt(repr.numberOfRound-1));
    HistoryRound r1 = ((HistoryRound) rounds.elementAt(repr.numberOfRound));

    for (int j=0 ; j < numberOfNodes ; j++) {
      Koord k = new Koord(r0.mynodes[j].mykoord.x,
			  r0.mynodes[j].mykoord.y + repr.verticalSize);
      r1.mynodes[j].setkoord(k);
    }
    if ( repr.numberOfRound > 0){
      for(int i = 0 ; i < messages.length ; i++){
        messages[i].to = r1.mynodes[messages[i].to.mynumber];
	
	messages[i].from = ((HistoryRound) rounds.elementAt(messages[i].sendingTime + 1))
			   .mynodes[messages[i].from.mynumber];
      }
    }  
  }
  
  // Calculate the coordinates of a Node, this function is not
  // important, because the nodes and the rounds can be moved
  private Koord setkoord(int mynumber) {
    Koord k;
    if(numberOfNodes > 7) k = new Koord(5 + mynumber * repr.horizontalSize,
				   30 + repr.numberOfRound * repr.verticalSize);
    else k = new Koord(5 + (mynumber * 400) / numberOfNodes,
		       30 + repr.numberOfRound * repr.verticalSize);
    return k;
  }
  
  // Recalculate the position of the nodes when the mouse is clicked
  // and dragged at the last node of the first round: Horizontal_moved
  // the Xposition of the mouse is as parameter.
  public void move_X(int x) {
    int space = (x-5)/(numberOfNodes-1);
    for ( int i = 0; i <= repr.numberOfRound; i++)
      {
	HistoryRound r =(HistoryRound) rounds.elementAt(i); 
	for(int j = 0 ;j < numberOfNodes ; j++) {
	  Koord k1 = new Koord(j * space, r.mynodes[j].mykoord.y);
	  r.mynodes[j].setkoord(k1);
	}
      }

  }
  
  // Recalculate the position of the nodes after the considered Round
  // where the mouse is clicked and dragged at the last node of a round
  // (not the first round): Vertical_moved the Yposition of the mouse
  // and the number of the round are the parameters
  public void move_Y(int y, int numberOfRound) {
    HistoryRound r0 = ((HistoryRound) rounds.elementAt(numberOfRound));
    HistoryRound r1 = ((HistoryRound) rounds.elementAt(numberOfRound-1));

    int expend = y - r0.mynodes[numberOfNodes-1].mykoord.y;
    int test = r0.mynodes[numberOfNodes-1].mykoord.y-
      r1.mynodes[numberOfNodes-1].mykoord.y;

    if (test > 30 ) {
      for ( int i = numberOfRound ; i <= repr.numberOfRound;i++) {
	HistoryRound r2 = ((HistoryRound) rounds.elementAt(i));

	for(int j = 0 ;j < numberOfNodes ; j++) {
	  Koord tmp = new Koord(r2.mynodes[j].mykoord.x,r2.mynodes[j].mykoord.y+expend);
	  r2.mynodes[j].setkoord(tmp);
	}
      }
      
    }
    else {
      for ( int i = numberOfRound ; i <= repr.numberOfRound;i++) {
	HistoryRound t2 = ((HistoryRound) rounds.elementAt(i));
	for(int j = 0 ;j < numberOfNodes ; j++) {
	  Koord tmp = new Koord(t2.mynodes[j].mykoord.x,t2.mynodes[j].mykoord.y+1);
	  t2.mynodes[j].setkoord(tmp);
	}
      }
    }
  }
}
