

import java.awt.*;
import java.io.*;

public class HistoryNode
{
  Koord dim; 
  String mylabel;
  int mynumber;
  Koord mykoord;
  
  public HistoryNode(int i) {
    dim = new Koord(20, 20);
    mynumber = i;
    mylabel = new String("" + (mynumber + 1));
  }

  /** Paint a HistoryNode
   */
  public void paint(Graphics g) {
    FontMetrics fm = g.getFontMetrics();
    g.setColor(Color.black);
    g.drawOval(mykoord.x,mykoord.y,dim.x,dim.y);
    g.setColor(Color.blue);
    g.fillOval(mykoord.x,mykoord.y,dim.x,dim.y);
    g.setColor(Color.white);
    g.drawString(mylabel, 
                 mykoord.x+(dim.x - fm.stringWidth(mylabel))/2, 
                 mykoord.y+(dim.y + fm.getAscent())/2 );
  }
  
  /** Return the number of the HistoryNode */
  public int get_mynumber() {
    return this.mynumber;
  }
  
  /** Set the coordinates of a node */
  public void setkoord(Koord k) {
    mykoord = (Koord) k;
  }

  /** Get the X position of the base of a node */
  public int getX() {
    return mykoord.x + dim.x/2;
  }

  /** get the Y position of the base of a node */
  public int getY() {
    return mykoord.y + dim.y;
  }
  
  /** Look if point p is in the rectangle created around the HistoryNode */
  public boolean isIn(Point p) {
    Rectangle r = new Rectangle(mykoord.x, mykoord.y, dim.x, dim.y);
    return (r.contains(p.x, p.y));
  }

  public void printGraphic(PrintWriter tmp) {
    tmp.println(" <Ellipse ");
    tmp.println("  <Unique 105695>");
    tmp.println("  <Pen 0>");
    tmp.println("  <PenWidth  0.5 pt>");

    tmp.println("  <ObColor `Blau'>");
    tmp.println("  <Fill 0>");
    tmp.println("  <DashedPattern ");
    tmp.println("   <DashedStyle Solid >");
    tmp.println("  > # end of DashedPattern");
    tmp.println("  <Overprint No >");
    tmp.println("  <ShapeRect "
	        + (mykoord.x) + "pt "
		+ (mykoord.y) + "pt "
		+ dim.x + "pt "
		+ dim.y + "pt>");
    tmp.println("  <BRect "
		+ mykoord.x + "pt "
		+ mykoord.y + "pt "
		+ dim.x + "pt "
		+ dim.y + "pt>");
    tmp.println(" > # end of Ellipse");

   tmp.println(" <Ellipse ");
    tmp.println("  <Unique 105695>");
    tmp.println("  <Pen 0>");
    tmp.println("  <PenWidth  0.5 pt>");

    tmp.println("  <ObColor `Schwarz'>");
    tmp.println("  <Fill 15>");
    tmp.println("  <DashedPattern ");
    tmp.println("   <DashedStyle Solid >");
    tmp.println("  > # end of DashedPattern");
    tmp.println("  <Overprint No >");
    tmp.println("  <ShapeRect "
	        + (mykoord.x) + "pt "
		+ (mykoord.y) + "pt "
		+ dim.x + "pt "
		+ dim.y + "pt>");
    tmp.println("  <BRect "
		+ mykoord.x + "pt "
		+ mykoord.y + "pt "
		+ dim.x + "pt "
		+ dim.y + "pt>");
    tmp.println(" > # end of Ellipse");

    tmp.println(" <TextLine ");
    tmp.println("  <Unique 584730>");
    tmp.println("  <Overprint No >");
    tmp.println("  <ObColor `Wei\\xa7 '>");
    tmp.println("  <TLOrigin " + (mykoord.x + dim.x / 2) + " pt "
	        + (mykoord.y + dim.y / 2 + 4) + " pt>");
    tmp.println("  <TLAlignment Center>");
    tmp.println("  <TLLanguage German>");
    tmp.println("  <Font ");
    tmp.println("   <FTag `'>");
    tmp.println("   <FFamily `Helvetica'>");
    tmp.println("   <FWeight `Regular'>");
    tmp.println("   <FPostScriptName `Helvetica'>");
    tmp.println("   <FPairKern No >");
    tmp.println("   <FSize  14.0 pt>");
    tmp.println("   <FColor `Wei\\xa7 '>");
    tmp.println("  > # end of Font");
    tmp.println("  <String `" + mylabel + "'>");
    tmp.println(" > # end of TextLine");
    
  }

}
