import java.util.*;
import sysPr.*;

/** This class provides interfaces for
 *  representations that monitor the message exchange
 *  and for panels controling the simulation
 */
public class SimManager {
  int[] decisions;  // Used for choosing colors
  Algorithm mySystem;
  Vector msgs;

  public SimManager(Algorithm s) {
    msgs = new Vector();
    mySystem = s;
    // SystemPrinter.println("SimManager instantiated");
    decisions = new int[mySystem.getNumberOfNodes()];
    for (int i = 0; i < mySystem.getNumberOfNodes(); i++) decisions[i] = 0;
  }

   // method for a panel to simulate one timestep
   public void nextTimestep(Vector messageQueue) {
     System.out.println("SimManager.nextTimestep called; " + messageQueue.size() + " messages arrived");
     Enumeration iter = messageQueue.elements();
     if (iter.hasMoreElements()) {
       while (iter.hasMoreElements()) {
         Object tmp = iter.nextElement();
	 msgs.addElement(tmp); 
       }
     }
     mySystem.getHistoryFrame().notifyNextTimestep();
     mySystem.getGraphFrame().notifyNextTimestep();
   }
   
   public Vector getMessages() {return msgs;}
   public Vector getsentMessages() {return (Vector)msgs.clone();}
   public Vector getreceivedMessages() {return (Vector)msgs.clone();}
}
